'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tableResolver = require('table-resolver');

var resolve = _interopRequireWildcard(_tableResolver);

var _searchtabular = require('searchtabular');

var search = _interopRequireWildcard(_searchtabular);

var _sortabular = require('sortabular');

var sort = _interopRequireWildcard(_sortabular);

var _treetabular = require('treetabular');

var tree = _interopRequireWildcard(_treetabular);

var _redux = require('redux');

var _lodash = require('lodash');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function processRows(_ref) {
  var movingRow = _ref.movingRow,
      query = _ref.query,
      sortingColumns = _ref.sortingColumns,
      idField = _ref.idField,
      parentField = _ref.parentField,
      columns = _ref.columns;

  // Moving rows is allowed only when there's no sort/search so we can skip a few
  // operations there to speed it up.
  return (0, _redux.compose)(tree.filter({ fieldName: 'showingChildren', parentField: parentField }), movingRow ? id : tree.wrap({
    operations: [sort.sorter({
      columns: columns,
      sortingColumns: sortingColumns,
      sort: _lodash.orderBy,
      strategy: sort.strategies.byProperty
    })],
    idField: idField
  }), movingRow ? id : search.highlighter({ columns: columns, matches: search.matches, query: query }), movingRow ? id : tree.search({
    operation: search.multipleColumns({ columns: columns, query: query }),
    idField: idField,
    parentField: parentField
  }), resolve.resolve({
    columns: columns,
    method: function method(extra) {
      return (0, _redux.compose)(resolve.index(extra), resolve.byFunction('cell.resolve')(extra), resolve.nested(extra));
    }
  }));
}

function id(a) {
  return a;
}

exports.default = processRows;