'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactabularTable = require('reactabular-table');

var Table = _interopRequireWildcard(_reactabularTable);

var _reactabularSticky = require('reactabular-sticky');

var Sticky = _interopRequireWildcard(_reactabularSticky);

var _reactabularDnd = require('reactabular-dnd');

var dnd = _interopRequireWildcard(_reactabularDnd);

var _reactabularVirtualized = require('reactabular-virtualized');

var Virtualized = _interopRequireWildcard(_reactabularVirtualized);

var _redux = require('redux');

var _selectabular = require('selectabular');

var select = _interopRequireWildcard(_selectabular);

var _lodash = require('lodash');

var _processRows = require('./process-rows');

var _processRows2 = _interopRequireDefault(_processRows);

var _types = require('./types');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EasyTable = function (_React$Component) {
  _inherits(EasyTable, _React$Component);

  function EasyTable(props) {
    _classCallCheck(this, EasyTable);

    var _this = _possibleConstructorReturn(this, (EasyTable.__proto__ || Object.getPrototypeOf(EasyTable)).call(this, props));

    _this.state = {
      selectedRow: {}
    };

    _this.selectRow = _this.selectRow.bind(_this);
    _this.onRow = _this.onRow.bind(_this);

    // References to header/body elements so they can be
    // kept in sync while scrolling.
    _this.tableHeader = null;
    _this.tableBody = null;

    // Drag and drop for rows
    _this.onCanMoveRow = _this.onCanMoveRow.bind(_this);
    _this.onMoveRowStart = _this.onMoveRowStart.bind(_this);
    _this.onMoveRowEnd = _this.onMoveRowEnd.bind(_this);
    _this.movingRow = false;
    return _this;
  }

  _createClass(EasyTable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // We have refs now. Force update to get those to Header/Body.
      this.forceUpdate();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          rowKey = _props.rowKey,
          query = _props.query,
          headerExtra = _props.headerExtra,
          sortingColumns = _props.sortingColumns,
          tableWidth = _props.tableWidth,
          tableHeight = _props.tableHeight,
          components = _props.components,
          idField = _props.idField,
          parentField = _props.parentField,
          headerRows = _props.headerRows,
          columns = _props.columns,
          classNames = _props.classNames,
          onRow = _props.onRow;

      var tableComponents = _extends({}, components, {
        body: {
          wrapper: Virtualized.BodyWrapper,
          row: dnd.draggableRow(Virtualized.BodyRow)
        }
      });
      var selectedRow = this.state.selectedRow;


      if (hasDraggableHeaders(columns)) {
        tableComponents.header = {
          cell: dnd.Header
        };
      }

      // Escape early if there are no columns to display
      if (!columns.length) {
        return null;
      }

      var rows = (0, _processRows2.default)({
        movingRow: this.movingRow,
        query: query,
        sortingColumns: sortingColumns,
        idField: idField,
        parentField: parentField,
        columns: columns
      })(this.props.rows);
      var selectedRowIndex = getSelectedRowIndex({
        rows: this.props.rows,
        rowKey: this.props.rowKey,
        selectedRow: selectedRow
      });

      return select.byArrowKeys({
        rows: rows,
        selectedRowIndex: selectedRowIndex,
        onSelectRow: this.selectRow
      })(_react2.default.createElement(
        Table.Provider,
        {
          className: classNames.table && classNames.table.wrapper,
          components: tableComponents,
          columns: columns,
          style: { width: tableWidth }
        },
        _react2.default.createElement(
          Sticky.Header,
          {
            headerRows: headerRows,
            className: classNames.header && classNames.header.wrapper,
            style: {
              maxWidth: tableWidth
            },
            ref: function ref(tableHeader) {
              _this2.tableHeader = tableHeader && tableHeader.getRef();
            },
            tableBody: this.tableBody
          },
          headerExtra
        ),
        _react2.default.createElement(Virtualized.Body, {
          className: classNames.body && classNames.body.wrapper,
          rows: rows,
          rowKey: rowKey,
          onRow: this.onRow,
          style: {
            maxWidth: tableWidth
          },
          height: tableHeight,
          ref: function ref(tableBody) {
            _this2.tableBody = tableBody && tableBody.getRef();
          },
          tableHeader: this.tableHeader
        })
      ));
    }
  }, {
    key: 'onRow',
    value: function onRow(row, _ref) {
      var _this3 = this;

      var rowIndex = _ref.rowIndex,
          rowKey = _ref.rowKey;
      var _props2 = this.props,
          idField = _props2.idField,
          onRow = _props2.onRow,
          onMoveRow = _props2.onMoveRow;

      var _onRow = onRow(row, { rowIndex: rowIndex, rowKey: rowKey }),
          className = _onRow.className,
          props = _objectWithoutProperties(_onRow, ['className']);

      var ret = _extends({
        rowId: row[idField],
        onClick: function onClick() {
          return _this3.selectRow(rowIndex);
        },
        onMove: onMoveRow,
        onCanMove: this.onCanMoveRow,
        onMoveStart: this.onMoveRowStart,
        onMoveEnd: this.onMoveRowEnd
      }, props);

      var cls = (0, _classnames2.default)(className, row.selected && 'selected-row');

      if (cls) {
        ret.className = cls;
      }

      return ret;
    }
  }, {
    key: 'onCanMoveRow',
    value: function onCanMoveRow() {
      var _props3 = this.props,
          query = _props3.query,
          sortingColumns = _props3.sortingColumns;


      return (0, _lodash.values)(query).filter(id).length === 0 && (0, _lodash.values)(sortingColumns).filter(id).length === 0;
    }
  }, {
    key: 'onMoveRowStart',
    value: function onMoveRowStart() {
      this.movingRow = true;
    }
  }, {
    key: 'onMoveRowEnd',
    value: function onMoveRowEnd() {
      this.movingRow = false;

      // Done, force update to skip optimization and sort again
      this.forceUpdate();
    }
  }, {
    key: 'selectRow',
    value: function selectRow(selectedRowIndex) {
      var _props4 = this.props,
          rowKey = _props4.rowKey,
          rows = _props4.rows;

      var selectedRowId = rows[selectedRowIndex][rowKey];
      var result = (0, _redux.compose)(select.rows(function (row) {
        return row[rowKey] === selectedRowId;
      }), select.none)(rows);
      var selectedRow = result.selectedRows[0];

      this.props.onSelectRow({
        selectedRowId: selectedRow && selectedRow[rowKey],
        selectedRow: selectedRow
      });

      // XXX: Push this outside of Table entirely. No need
      // to maintain state here at all.
      this.setState({
        selectedRow: selectedRow
      });
    }
  }]);

  return EasyTable;
}(_react2.default.Component);

EasyTable.propTypes = _types.propTypes;
EasyTable.defaultProps = _types.defaultProps;

function hasDraggableHeaders(columns) {
  return columns.some(function (column) {
    return column.header && column.header.draggable;
  });
}

function getSelectedRowIndex(_ref2) {
  var rows = _ref2.rows,
      selectedRow = _ref2.selectedRow,
      rowKey = _ref2.rowKey;

  return (0, _lodash.findIndex)(rows, _defineProperty({}, rowKey, selectedRow[rowKey]));
}

function id(a) {
  return a;
}

exports.default = EasyTable;